/*****************************************************************/
/*
	    C de Cerca 2
	    Funciones, parmetros y texto en el Mac
	        
			Rafael Escot - Enric Herrera
			BlauSoft S.L. para MacFormat Espaa - 1996
					
			La descripcin del cdigo y la informacin sobre cmo preparar
			el entorno de programacin y generar estos programas, est contenida
			en el ejemplar de MacFormat que los acompaa.

*/
/*****************************************************************/



/****************************************************************	*/
/* PROTOTIPOS	DE LAS FUNCIONES QUE HEMOS CREADO									 	*/
/* PARA NUESTRO PROGRAMA																					*/ 
/****************************************************************	*/
void		main(void);				/* Esta funcin NO puede tener otro nombre */
void		MF_InitToolbox 		(void);
void 		MF_AbreMiVentana	(void);
void 		MF_EscribeTexto		(short codigo);
void 		MF_bucle_principal(void);



/****************************************************************	*/
/* CONSTANTES Y VARIABLES GLOBALES									 							*/
/* RELACIONADAS CON LA VENTANA QUE ABRIREMOS											*/ 
/****************************************************************	*/
/* La ventana que abriremos ser creada dinmicamente por medio de
la funcin NewWindow() que nos devolver un puntero a la estructura de
la nueva ventana, Declaramos pues, una variable adecuada... */
	
WindowPtr		gMiVentana = nil;
																


/*--------------------------------------------------------------------*/
/* A PARTIR DE ESTE PUNTO, APARECE EL CODIGO DE LAS FUNCIONES CREADAS
	 ESPECIFICAMENTE PARA ESTE PROGRAMA. */
/*--------------------------------------------------------------------*/



/****************************************************************	*/
/* main()                                     			            	*/
/****************************************************************	*/
/*
	Todos los programas en C poseen una funcin que debe llamarse main.
	Cuando un programa se pone en marcha, lo hace SIEMPRE ejecutando
	en primer lugar la funcin main().
	Es el punto de entrada a nuestra aplicacin.
	
	Recibe: 	nada
	Que hace: Llama otras funciones que preparan la aplicacin...
	Salida:  	void (nada)
*/
void	main (void)
{	
	/* Antes de hacer nada, debemos inicializar la Toolbox del Mac 				*/
	/* Como sea que el procedimiento a seguir para inicializar la Toolbox */
	/* es casi siempre el mismo, hemos creado una funcin MF_InitToolbox()*/
	/* que contiene las llamadas estndar de inicializacin */

	MF_InitToolbox();
	
	/* Ahora empleamos una funcin que se encargar de abrir una ventana */
	MF_AbreMiVentana();
	
	/* Una vez abierta la ventana, podemos escribir algo de texto en ella */
	MF_EscribeTexto(0);
	
	/* Y ya podemos entrar en el bucle principal, que se encargar de
		 recoger e interpretar las acciones del usuario */	
	MF_bucle_principal();
	
	/* Cuando el bucle principal haya terminado, ser porque el usuario
		 desea acabar el programa.
		 Debemos liberar la memoria ocupada por nuestra ventana. */
	DisposeWindow(gMiVentana);
	
  /* Y ya est, al acabarse la funcin main(), el Sistema cerrar
		 nuestra aplicacin de forma automtica */
	
} /* Fin de main() y del programa */



/****************************************************************	*/
/* MF_bucle_principal		                                         	*/
/****************************************************************	*/
/*
	Recibe: 	nada
	Que hace: Entra en un bucle y espera que se produzca una accin
						Segn cual sea esta, reacciona llamando una de las funciones que
						hemos creado en esta demo.
	Salida:  	nada
*/
void MF_bucle_principal(void)
{
	short contador = 1; /* declaramos e inicializamos una variable 
												 que nos servir para contar las veces que 
												 ejecutaremos la funcin MF_EscribeTexto()
											*/
											
	long	dummy;				/* Una variable long que la funcin Delay()	requiere */
	
	/* Mientras contador sea menor o igual a 3 */
	while(contador <= 3)
	{
	
		while (Button() == 0) 
				;	/* Nos paramos a esperar que sea pulsado el ratn
						 Button() es una funcin que devuelve el valor 0 si el botn 
						 del ratn no est pulsado */
		
		MF_EscribeTexto(contador);	/* OK. Han pulsado el botn
																	Ejecutamos la funcin MF_EscribeTExto()
																	pasandole el valor de contador.
																	La primera vez ser = 1, luego 2 etc... */
																
		Delay(30,&dummy);			/*  Delay() es una funcin del Mac que detiene
															todo proceso durante el tiempo indicado en
															su primer parmetro. Las unidades empleadas
															son 1/60" seg.
															As pues, 30 equivale a medio segundo de espera */
															
		contador = contador+1;/* Ahora incrementamos el contador sumndole 1.*/
		
	} /* fin del bucle while(contador <= 3) */
	
	Delay(60,&dummy); /* Un poco ms de espera (1 segundo en este caso) */
	
} /* Fin de la funcin MF_bucle_principal() */



/****************************************************************	*/
/* MF_InitToolbox 																								*/
/****************************************************************	*/
/*
	Inicializa la Toolbox Macintosh. El orden de llamada a las diversas
	rutinas es significativo! No lo cambie.

	Recibe: 	nada
	Cambia:  	nada en la aplicacin
	Salida:  	nada
*/
void MF_InitToolbox (void)
{

	InitGraf(&qd.thePort);
	InitFonts();
	FlushEvents(everyEvent,0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
								
} /* Fin de MF_InitToolbox() */


	
/****************************************************************	*/
/* MF_AbreMiVentana		                                           	*/
/****************************************************************	*/
/*
	Abre la ventana (la nica) de nuestro programa. Las funciones empleadas
	y el significado de los parmetros que utilizamos se comentarn en posteriores
	versiones de esta aplicacin.
	
	Recibe: 	nada
	Que hace: Crea una ventana...
	Salida:  	void (nada)
*/
void MF_AbreMiVentana(void)
{
/* Declaracin e inicializacin de una variable de tipo Rect */					
	Rect	miRectangulo = { 48, 8,108, 300 };
		
	gMiVentana = NewWindow(	nil,
													&miRectangulo,
													"\pC de Cerca - 2",
													true,
													documentProc,
													(WindowPtr)-1L,
													false,
													nil);
  
  if(gMiVentana == nil) 
  		ExitToShell();	/* Si la creacin de la ventana falla, 
  											posiblemente sea debido a falta de memoria libre
  											Lo ms aconsejable es salir de la aplicacin */
  	
} /* Fin de MF_AbreMiVentana() */



/****************************************************************/
/* MF_EscribeTexto 		    																			*/ 
/****************************************************************/
/*
	Dibuja en nuestra ventana un texto.
		
	Recibe: 	Un valor (short) que se emplea en una expresin condicional
						de tipo switch/case, para determinar qu texto escribir.
	Cambia:  	Borra los contenidos de la ventana y escribe un texto.
	Salida:   nada
*/
void MF_EscribeTexto(short codigo)
{
	SetPort(gMiVentana);	/* Antes de dibujar o escribir nada, debemos  */
	 											/* indicar al Sistema en que ventana deseamos */
	 											/* hacerlo */	
	 														
	EraseRect(&gMiVentana->portRect); /* Borramos los contenidos */
	MoveTo(10,30);										/* Y ajustamos la posicin inicial */
	 																			/* en la que vamos a escribir */
	 		
	/* Una expresin condicional del tipo switch...case */
	switch(codigo) 
	{
	 	/* Segn el valor del parmetro recibido (codigo) */
	 	/* se ejecutar una (y slo una) de las siguientes opciones. */
	 	/* De hecho, se ejecuta el cdigo comprendido entre las sentencias */
	 	/* case y break */
	 			
	 	case 0: /* Por ejemplo, si cdigo = 0 */
 			DrawString("\pPulse el botn del ratn..."); /* <-- se ejecuta esto */
 			break; /* y el programa 'salta' hasta el final del switch */
 		case 1:
 			DrawString("\pSwitch-case n 1. Pulse otra vez...");
 			break;
 		case 2:
 			DrawString("\pSwitch-case n 2. Pulse una vez ms...");
 			break;
 		case 3:
 			DrawString("\pSwitch-case n 3. Esta ha sido la ltima...");
 			break;
 		default:
 			DrawString("\pMacFormat. C de Cerca n 2");
 			break;
 					
 	} /* Fin de switch(codigo) */

}/* Fin de MF_EscribeTexto() */